<div {{did-insert this.setup}}>
  {{#if this.isLoading}}
    <div class="spinner-border text-dark" role="status">
      <span class="visually-hidden">Loading...</span>
    </div>
  {{else}}
    <Editor::Properties::OptionContainer @label={{t "option-panel.model"}} as |id|>
      <Input::Select class="model-name" id={{id}} @list={{this.modelList}} @value={{this.model}} @onChange={{this.modelChanged}} />
    </Editor::Properties::OptionContainer>

    {{#if this.value.useSelectedModel}}
      <Editor::Properties::OptionContainer @label={{t "option-panel.property"}} as |id|>
        <Input::Select id={{id}} class="model-property" @list={{this.modelPropertyList}} @value={{this.modelProperty}} @onChange={{this.modelPropertyChanged}} />
      </Editor::Properties::OptionContainer>
    {{else}}
      <div class="btn-group ms-1 mt-2 mb-3" role="group">
        <Input @type="checkbox" @checked={{this.isAll}} class="btn-check btn-check-all" id="{{this.elementId}}-all" />

        <label class="btn btn-outline-primary" for="{{this.elementId}}-all">
          {{t "all"}}
        </label>

        <Input @type="checkbox" @checked={{this.isIds}} class="btn-check btn-check-ids" id="{{this.elementId}}-ids" />

        <label class="btn btn-outline-primary" for="{{this.elementId}}-ids">
          {{t "items"}}
        </label>

        <Input @type="checkbox" @checked={{this.isGroups}} class="btn-check btn-check-groups" id="{{this.elementId}}-groups" />

        <label class="btn btn-outline-primary" for="{{this.elementId}}-groups">
          {{t "option-panel.groups"}}
        </label>

        <Input @type="checkbox" @checked={{this.isParameters}} class="btn-check btn-check-parameters" id="{{this.elementId}}-parameters" />
        <label class="btn btn-outline-primary" for="{{this.elementId}}-parameters">
          {{t "option-panel.parameters"}}
        </label>
      </div>
    {{/if}}

    {{#unless this.team}}
      {{#if this.isTeam}}
        <div class="form-floating">
          <Input::Select class="select-source-team" @list={{this.allTeams}} @value={{this.selectedTeam}} @onChange={{this.itemChanged}} />
          <label for="floatingSelect">{{capitalize (t "team")}}</label>
        </div>
      {{/if}}
    {{/unless}}

    {{#if this.isIds}}
      <Input::IdList class="model-group-id-list model-group" @team={{this.team}} @model={{this.model}} @value={{this.ids}} @onChange={{this.changeValues}} id="{{this.elementId}}-id-list" />
    {{/if}}

    {{#if this.isGroups}}
      <div>
        {{#each this.groups as |group index|}}
          <div class="input-group p-3">
            {{! template-lint-disable require-input-label }}
            <Input class="form-control input-group-name-{{index}}" @value={{group.name}} />
            <button class="btn btn-outline-danger btn-delete-group-{{index}}" type="button" {{on "click" (fn this.deleteGroup index)}}>
              <FaIcon @icon="trash" />
            </button>
          </div>

          <Input::IdList class="model-group-{{index}} model-group" @team={{this.team}} @value={{group.ids}} @model={{this.model}} @onChange={{fn this.changeIds group}} />
        {{/each}}
        <button class="btn btn-outline-primary btn-groups-add" type="button" {{on "click" this.addGroup}}>
          {{t "add group"}}
        </button>
      </div>
    {{/if}}

    {{#if this.isParameters}}
      <Input::Options::ModelParameters @team={{this.team}} @model={{@model}} @value={{@value}} @onChange={{this.changeParameters}} />
    {{/if}}
  {{/if}}
</div>